/*
   Projekt z Podstaw Informatyki 2003/2004
   Napisac algorytm i funkcje sumujaca dwie macierze oraz program glowny
   demonstrujacy jej dzialanie.
*/

#include <stdio.h>
#include <conio.h>

void sumowanie_macierzy (int w, int k); //deklaracja funkcji

/* !!!!!!!!!!!!!!!!!!!!! PROGRAM GLOWNY !!!!!!!!!!!!!!!!!!!!!!!!!*/
void main (void)
{
int m,n; //zmienne typu calkowitego okreslajace ilosc kolumn i wierszy macierzy
int c;


textmode(3);
clrscr(); //czyszcze ekran przed wyswietleniem
gotoxy(25,10); //ustawiam kursor w odpowiednim mejscu ekranu


/* Wyswietlam informacje o projekcie */
printf("PROJEKT Z PODSTAW INFORMATYKI\n\n\n\n\r");
printf(" Zadanie 2:\n Napisac algorytm i funkcje sumujaca dwie macierze oraz program glowny \n demonstrujacy jej dzialanie.");
printf("\n\n\n\r Zalozenia:\n Funkcja nie wykorzystuje zadnych zmiennych globalnych,\n umozliwia wykonanie operacji na macierzach o roznych wymiarach");
printf("\n (ustalonych na etapie wywolania funkcji), nie modyfikuje macierzy wejsciowej.\n Program glowny wyswietla dane wejscowe oraz wynikowe w postaci macierzy.\n");
_setcursortype(_NOCURSOR);
/* Koniec wyswietlania informacji */

getch(); //czekam na nacisniecie dowolnego klawisza

   clrscr(); //czyszcze ponownie ekran
   _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny

   // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy
   printf("\nPODAJ ROZMIAR MACIERZY\nLiczba wierszy macierzy: ");
   scanf("%d",&n);
   printf("Liczba kolumn macierzy:");
   scanf("%d",&m);
   // Koniec wyswietlania informacji


do{
   /* Jezeli chce ponownie wprowadzic dane to ... */
   if (c=='w')
      {
      clrscr(); //czyszcze ponownie ekran
      _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny

      // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy A i B
      printf("\nPODAJ ROZMIAR MACIERZY\nLiczba wierszy macierzy:");
      scanf("%d",&n);

      printf("Liczba kolumn macierzy:");
      scanf("%d",&m);
      // Koniec wyswietlania informacji
      }

   if (c == 'k')
      {
      sumowanie_macierzy(n,m);
      }

      clrscr();
      textcolor(WHITE); //zmieniam kolor czcionki na bialy aby ...
      printf("\tPodana macierz ma wymiary %dx%d\n\n",n,m);
      cprintf("          W"); //podswietlic literke "W"
      printf("prowadz ponownie"); //dokanczam napis
      cprintf("          K"); //jak wyrzej z literka "K"
      printf("ontynuuj"); //i dokanczam napis
      cprintf("          Z"); //jak wyrzej z literka "K"
      printf("akoncz"); //i dokanczam napis
      _setcursortype(_NOCURSOR); //ukrywam migajacy kursor
      lowvideo();
      c= getch(); //czekam na wprowadzenie znaku z klawiatury


} while(c!='z');

}
/* !!!!!!!!!!!!!!!!!! KONIEC PROGRAMU GLOWNEGO !!!!!!!!!!!!!!!!!! */





/* !!!!!!!!!! FUNKCJA SUMUJACA DWIE MACIERZE !!!!!!!!!! */
void sumowanie_macierzy (int w, int k)
{
float tab_A[100][100], tab_B[100][100], tab_C[100][100];
int i,j; //zmienne do indeksowania macierzy przy wprowadzaniu danych
int c;

clrscr(); //czyszcze ponownie ekran
_setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny


/* WPROWADZAM DANE DO MACIERZY "A" */
//wczytywanie elementow macierzy - wczytuje elementy wierszami
for(i=0;i<w;i++)
   {
   printf("\nWprowadz elementy %d-go wiersza macierzy 'A'\n",i+1);
   for(j=0;j<k;j++)
      scanf("%f",&tab_A[i][j]);
   }

/* WPROWADZAM DANE DO MACIERZY "B" */
//wczytywanie elementow macierzy - wczytuje elementy wierszami
for(i=0;i<w;i++)
   {
   printf("\nWprowadz elementy %d-go wiersza macierzy 'B'\n",i+1);
   for(j=0;j<k;j++)
      scanf("%f",&tab_B[i][j]);
   }



/* FUNKCJA SUMUJACA MACIERZE */
for(i=0;i<=w;i++) //rozpoczynam od elmentu 0,0 i koncze na elemencie w - ilosci wierszy
   for(j=0;j<=k;j++) //ropoczynam od elementu 0,0 i koncze na elemencie k - ilosc kolumn
      tab_C[i][j]=tab_A[i][j]+tab_B[i][j]; //w odpowiednie meijsce macierzy C wpisuje wartosc rowna sumie odpowiednich elementow macierzy A i B

       clrscr(); //czyszcze ekran
       textcolor(WHITE); //zmieniam kolor
       printf("      Macierz "); //wyswietlam napis
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A+B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       _setcursortype(_NOCURSOR); //ukrywam kursor
       lowvideo(); //szare literki

do{

  c= getch(); //czekam na wprowadzeni znaku z klawiatury
  if (c == 'a') //jezeli znak wprowadzony to 'a' wtedy...
     {
       clrscr(); //czyszcze ekran
       textcolor(WHITE); //zmieniam kolor czcionki
       printf("      Macierz "); //wyswietlam napisy na ekranie
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A+B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'A'");
       _setcursortype(_NOCURSOR); //ukrywam kursor
       lowvideo(); //przechodze w tryb szaryc liter
     for(i=0;i<w;i++) //wyswietlam macierz wiersz po wierszu
	{
	printf("\n");
	for(j=0;j<k;j++)
	printf("%8.2f",tab_A[i][j]);
	}
     }
   else
  if (c == 'b') //jezeli klawisz 'b' dzieje sie to samow jak wyrzej
      {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A+B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'B'");
       _setcursortype(_NOCURSOR);
       lowvideo();
     for(i=0;i<w;i++)
	{
	printf("\n");
	for(j=0;j<k;j++)
	printf("%8.2f",tab_B[i][j]);
	}
      }
   else
  if (c == 'c')
      {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       printf("      Macierz ");
       cprintf("C");
       printf("=A+B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'C'");
       _setcursortype(_NOCURSOR);
       lowvideo();
      for(i=0;i<w;i++)
	{
	printf("\n");
	for(j=0;j<k;j++)
	printf("%8.2f",tab_C[i][j]);
	}
      }
  }
  while(c!='w');
}
/* !!!!!!!!!! KONIEC !!!!!!!!!! */